#!/usr/bin/python2.7
# Copyright header

import csv
from pg import DB
import sys

try:
	date_close1 = sys.argv[1]
except IndexError:
	print("No start date given. Plase give a start date.")
	sys.exit(1)

try:
	date_close2 = sys.argv[2]
except IndexError:
	print("No end date given. Please give an and date.")
	sys.exit(1)

if date_close2 > date_close1:
	pass
else:
	print("The first date must be lower than the second date!")
	sys.exit(1)

try:
	with open ('/etc/odoo.secret', 'rb') as db_passwd_file:
		db_passwd = db_passwd_file.read()
except IOError:
	print("Please provide a secret file for the database user!")
	sys.exit(1)

db = DB(dbname='univention', host='localhost', port=5432, user='odoo', passwd='%s' % (db_passwd, ))
mamreportfile = open('/home/groups/66_verkauf/reports/weekly-mam-report/mamreport_%s_%s.csv' % (date_close1, date_close2,) , 'wb')
writer = csv.writer(mamreportfile)

# Get all open optis
optis = db.query("SELECT * FROM crm_lead WHERE type = 'opportunity' AND (active = TRUE OR (date_closed >= '%s' AND date_closed < '%s'))" % (date_close1, date_close2,)).dictresult()
# Get all Level 1 mail_messages_ids
level1_new = db.query("SELECT mail_message_id FROM mail_tracking_value WHERE new_value_char LIKE '%Level 1%'").dictresult()
# Get all Level 2 mail_messages_ids
level2_new = db.query("SELECT mail_message_id FROM mail_tracking_value WHERE new_value_char LIKE '%Level 2%'").dictresult()
# Get all Level 3 mail_messages_ids
level3_new = db.query("SELECT mail_message_id FROM mail_tracking_value WHERE new_value_char LIKE '%Level 3%'").dictresult()
# Get all Level 4 mail_messages_ids
level4_new = db.query("SELECT mail_message_id FROM mail_tracking_value WHERE new_value_char LIKE '%Level 4%'").dictresult()
# Get all Level 5 mail_messages_ids
level5_new = db.query("SELECT mail_message_id FROM mail_tracking_value WHERE new_value_char LIKE '%Level 5%'").dictresult()

# Get all old Level 1 optis (from OpenERP)
level1_old = db.query("SELECT res_id, date FROM mail_message WHERE body LIKE '%Level 1%' OR body = 'qualified'").dictresult()
# Get all old Level 2 optis (from OpenERP)
level2_old = db.query("SELECT res_id, date FROM mail_message WHERE body LIKE '%Level 2%' OR body = 'project planed'").dictresult()
# Get all old Level 3 optis (from OpenERP)
level3_old = db.query("SELECT res_id, date FROM mail_message WHERE body LIKE '%Level 3%' OR body = 'positive project decision'").dictresult()
# Get all old Level 4 optis (from OpenERP)
level4_old = db.query("SELECT res_id, date FROM mail_message WHERE body LIKE '%Level 4%' OR body = 'commitment'").dictresult()

# Get all Level 1 crm_lead_ids and dates
l1dates = {}
for message_id in level1_new:
	for l1date in db.query("SELECT res_id, date FROM mail_message WHERE id = %d" % (message_id['mail_message_id'], )).dictresult():
		res_id = l1date.pop("res_id")
		date = l1date.pop("date")
		l1dates[res_id] = date
for l1date in level1_old:
	res_id = l1date.pop("res_id")
	date = l1date.pop("date")
	l1dates[res_id] = date
	
# Get all Level 2 crm_lead_ids and dates
l2dates = {}
for message_id in level2_new:
	for l2date in db.query("SELECT res_id, date FROM mail_message WHERE id = %d" % (message_id['mail_message_id'], )).dictresult():
		res_id = l2date.pop("res_id")
		date = l2date.pop("date")
		l2dates[res_id] = date
for l2date in level2_old:
	res_id = l2date.pop("res_id")
	date = l2date.pop("date")
	l2dates[res_id] = date

# Get all Level 3 crm_lead_ids and dates
l3dates = {}
for message_id in level3_new:
	for l3date in db.query("SELECT res_id, date FROM mail_message WHERE id = %d" % (message_id['mail_message_id'], )).dictresult():
		res_id = l3date.pop("res_id")
		date = l3date.pop("date")
		l3dates[res_id] = date
for l3date in level3_old:
	res_id = l3date.pop("res_id")
	date = l3date.pop("date")
	l3dates[res_id] = date

# Get all Level 4 crm_lead_ids and dates
l4dates = {}
for message_id in level4_new:
	for l4date in db.query("SELECT res_id, date FROM mail_message WHERE id = %d" % (message_id['mail_message_id'], )).dictresult():
		res_id = l4date.pop("res_id")
		date = l4date.pop("date")
		l4dates[res_id] = date
for l4date in level4_old:
	res_id = l4date.pop("res_id")
	date = l4date.pop("date")
	l4dates[res_id] = date
	
# Get all Level 5 crm_lead_ids and dates
l5dates = {}
for message_id in level5_new:
	for l5date in db.query("SELECT res_id, date FROM mail_message WHERE id = %d" % (message_id['mail_message_id'], )).dictresult():
		res_id = l5date.pop("res_id")
		date = l5date.pop("date")
		l5dates[res_id] = date

# Get all salesman
salesmen = {}
for user in db.query("SELECT t1.id, t0.name FROM res_partner t0 LEFT JOIN res_users t1 ON t1.partner_id = t0.id WHERE login IS NOT NULL").dictresult():
    user_id = user.pop("id")
    user_name = user.pop("name")
    salesmen[user_id] = user_name

# Get all categories
lead_category = {}
for category in db.query("SELECT t0.lead_id, t1.name FROM crm_lead_tag_rel t0 LEFT JOIN crm_lead_tag t1 ON t1.id = t0.tag_id").dictresult():
	lead_id = category.pop('lead_id')
	cat_name = category.pop("name")
	lead_category[lead_id] = cat_name
	
#Get all stages
stages_dict = {}
for stage in db.query("SELECT id, name FROM crm_stage").dictresult():
	stage_id = stage.pop("id")
	stage_name = stage.pop("name")
	stages_dict[stage_id] = stage_name

# Get all customer name's per opti
customer_names = {}
for customer in db.query("SELECT t0.id, t2.name FROM crm_lead t0 LEFT JOIN res_partner t1 ON t0.partner_id = t1.id LEFT JOIN res_partner t2 ON t1.commercial_partner_id = t2.id").dictresult():
	customer_opti_id = customer.pop("id")
	customer_name = customer.pop("name")
	customer_names[customer_opti_id] = customer_name

# Get all assigned partners per opti
assigned_partner_names = {}
for assigned_partner in db.query("SELECT t1.id, t0.name from res_partner t0 LEFT JOIN crm_lead t1 ON t0.id = t1.partner_assigned_id WHERE t1.id IS NOT NULL").dictresult():
	assigned_partner_id = assigned_partner.pop("id")
	assigned_partner_name = assigned_partner.pop("name")
	assigned_partner_names[assigned_partner_id] = assigned_partner_name

crm_dict = {}
optinumber = 0
for opti in optis:
	customer = customer_names[opti["id"]]
	if opti["id"] in assigned_partner_names:
		assignedpartner = assigned_partner_names[opti["id"]]
	else:
		assignedpartner = ""
	if opti["id"] in lead_category:
		category = lead_category[opti["id"]]
	else:
		category = ""
	if opti["user_id"] in salesmen:
		saleman = salesmen[opti["user_id"]]
	else:
		saleman = ""
	if opti["probability"]:
		probability = opti["probability"]
	else:
		probability = ""
	if opti["stage_id"] in stages_dict:
		stage = stages_dict[opti["stage_id"]]
	else:
		stage = ""
	if opti["date_deadline"]:
		expectedclosing = opti["date_deadline"]
	else:
		expectedclosing = ""
	if opti["planned_revenue"]:
		expectedrevenue = opti["planned_revenue"]
	else:
		expectedrevenue = ""
	if opti["create_date"]:
		creationdate = opti["create_date"]
	else:
		creationdate
	if opti["id"] in l1dates:	
		level1 = l1dates[opti["id"]]
	else:
		level1 = ""
	if opti["id"] in l2dates:
		level2 = l2dates[opti["id"]]
	else:
		level2 = ""
	if opti["id"] in l3dates:
		level3 = l3dates[opti["id"]]
	else:
		level3 = ""
	if opti["id"] in l4dates:
		level4 = l4dates[opti["id"]]
	else:
		level4 = ""
	if opti["id"] in l5dates:
		level5 = l5dates[opti["id"]]
	else:
		level5 = ""
	if opti["date_closed"]:
		closed = opti["date_closed"]
	else:
		closed = ""
	optinumber += 1
	crm_dict[optinumber] = [customer, assignedpartner, category, saleman, probability, stage, expectedclosing, expectedrevenue, creationdate, level1, level2, level3, level4, level5, closed]

#### FINAL ####
# Write a pretty csv from all data gathered containing the following fields:
# customer, assignedpartner, category, salesman, probaility, stage, expectedclosing, expectedrevenue, creationdate, Level 1, Level 2, Level 3, Level 4, Level 5, closed
writer.writerow(["customer", "assignedpartner", "category", "salesman", "probaility", "stage", "expectedclosing", "expectedrevenue", "creationdate", "Level 1", "Level 2", "Level 3", "Level 4", "Level 5", "closed"])
for entry in crm_dict.itervalues():
	writer.writerow([entry[0], entry[1], entry[2], entry[3], entry[4], entry[5],entry[6], entry[7], entry[8], entry[9],entry[10], entry[11], entry[12], entry[13], entry[14]])

mamreportfile.close()
